<!DOCTYPE HTML>
<html>
<head>
<link rel="stylesheet" type="text/css" href="./css/font.css" />
</head>
<body>

<?php
ini_set('display_errors', 'On');
error_reporting(E_ALL);

$nmap = array();
$file = fopen("./map/default.txt","r");
while(! feof ($file))
{

    $nmap[] = str_split(fgets($file));
    
}
//print_r($nmap);
fclose($file);

$path = pathfind(1,1,11,10,$nmap);
    foreach($path as $coord)
    {
        $x = $coord[1];
        $y = $coord[2];
        $nmap[$y][$x] = "~";
    }
show($nmap);

echo "<br />";

$view = pathfind2(1,1,10,$nmap);
$view = buildview($view,1,1,10,$nmap);
show($view);

function show($nmap)
{
    //echo "<table border=0 cellspacing=0 cellpadding=0 frame=void>";
    echo "<table>";
    foreach($nmap as $line)
    {
        echo "<tr>";
        foreach($line as $char)
        {/*
            $img = "./lofi/lofi_dungeon8.gif";
            if($char=="." or $char=="~")
            {
                $img = "./lofi/lofi_dungeon24.gif";
            }
            if($char==" ")
            {
                $img = "./lofi/lofi_dungeon0.gif";
            }
            echo "<th><img src='".$img."' alt='".$char."' /></th>";
           */ echo "<th>".$char."</th>";
        }
        echo "</tr>";
    }
    echo "</table>";
}





//array(f, x, y, g, h)
//where
//h = heuristic
//f = sum
//g = cost from start

function buildview($area,$ax,$ay,$max,$map)
{
    $newmap = array();
    $nmax = (($max*2)+1);
    for($i=0;$i<$nmax;$i = $i + 1)
    {
        $newmap = array();
        for($j=0;$j<$nmax;$j = $j + 1)
        {
            $newmap[$i][] = " ";
        }
    }
    foreach($area as $node)
    {
        $x = $node[0];
        $y = $node[1];
        $newmap[$ay-$y][$ax-$x] = $map[$y][$x];
    }
    return $newmap;
}

//function pathfind2($ax, $ay ,$bx, $by, $map)
function pathfind2($ax,$ay,$max,$map)
{
    $close = array();
    $from = 0;
    //$h = heuristic($ax, $ay ,$bx, $by);
    //$open = array(array($h,$ax,$ay,0,$h,$from));
    $open = array(array(0,$ax,$ay,0,0,$from));
    while(!empty($open))
    {
        //=====================get the lowest from $open, move to closed
        $open = heapfy($open);
        $lowest = array_pop($open);
        $close[] = $lowest;
        //=================================if goal acheived then reconstruct
        //if(($lowest[1] == $bx and $lowest[2] == $by))
        if($lowest[0] >= $max)
        {
            //return reconstruct($close,$map);      //correct these
            return $close;
        }
        //=================================find all neighbor
        foreach(neighbor($lowest[1], $lowest[2]) as $tmp)
        {
            $x = $tmp[0];
            $y = $tmp[1];
            $new = make_node($x,$y,$map);
            //==================================if in closed
            if((find($x,$y,$close)==NULL) and ($new!=NULL))
            {
                $new[3] = $new[3] + $lowest[3];
                //$new[4] = heuristic($x, $y, $bx, $by);
                $new[0] = $new[3] + $new[4];
                $new[5] = $from;
                //================================if not in open
                $pmt = find($x,$y,$open);
                if($pmt == NULL)
                {
                    $open[] = $new;
                }
                elseif($new[3] < $open[$pmt][3])
                {
                    $open[$pmt] = $new;
                }
            }
        }
        $from = $from + 1;
    }
    return ;
}

function heuristic($ax, $ay ,$bx, $by)
{
    return abs($ax-$bx) . abs($ay-$by);
}

function neighbor($x, $y)
{
    $tmp = array();
    $tmp[] = array($x+1,$y);
    $tmp[] = array($x,$y+1);
    $tmp[] = array($x,$y-1);
    $tmp[] = array($x-1,$y);
    return $tmp;
}

function make_node($x,$y,$nmap)
{
    $cost = 1;
    if($nmap[$y][$x]=='.')
    {
        return array(0,$x,$y,$cost,0,0);
    }
}

function pathfind($ax, $ay ,$bx, $by, $map)
{
    $close = array();
    $from = 0;
    $h = heuristic($ax, $ay ,$bx, $by);
    $open = array(array($h,$ax,$ay,0,$h,$from));

    while(!empty($open))
    {
        //=====================get the lowest from $open, move to closed
        $open = heapfy($open);
        $lowest = array_pop($open);
        $close[] = $lowest;
        //=================================if goal acheived then reconstruct
        if($lowest[1] == $bx and $lowest[2] == $by)
        {
            return reconstruct($close,$map);      //correct these
        }
        //=================================find all neighbor
        foreach(neighbor($lowest[1], $lowest[2]) as $tmp)
        {
            $x = $tmp[0];
            $y = $tmp[1];
            $new = make_node($x,$y,$map);
            //==================================if in closed
            if((find($x,$y,$close)==NULL) and ($new!=NULL))
            {
                $new[3] = $new[3] + $lowest[3];
                $new[4] = heuristic($x, $y, $bx, $by);
                $new[0] = $new[3] + $new[4];
                $new[5] = $from;
                //================================if not in open
                $pmt = find($x,$y,$open);
                if($pmt == NULL)
                {
                    $open[] = $new;
                }
                elseif($new[3] < $open[$pmt][3])
                {
                    $open[$pmt] = $new;
                }
            }
        }
        $from = $from + 1;
    }
    return ;
}

function find($x,$y,$set)
{
    for($i=0;$i<sizeof($set);$i++)
    {
        if($set[$i][1]==$x and $set[$i][2]==$y)
        {
            return $i;
        }
    }
    return NULL;
}

function reconstruct($path,$map)
{
    $i = sizeof($path)-1;
    $a = array();
    while($i>0)
    {
        $a[] = $path[$i];
        $i = $path[$i][5];
    }
    return $a;
}

function heapfy($a)
{
    for($i=1;$i<sizeof($a);$i++)
    {
        $c = $i;
        while($c>0)
        {
            $p = ($c-1)/2;      //parent
            $cc = (sizeof($a)-$c)-1;
            $pp = (sizeof($a)-$p)-1;
            if($a[$cc][0] < $a[$pp][0])
            {
                //swap
                $tmp = $a[$pp];
                $a[$pp] = $a[$cc];
                $a[$cc] = $tmp;
            }
            $c = $p;
        }
    }
    return $a;
}

?>

</body>
</html>
